//thsi test a swicht with 32 cases all with same probability

import ewe.sys.Vm;
public class IfElseTree_switch32 implements OptiTest
{
  private static final String name="'switch' replaced by 'if-else-tree' 32";


  public void findAndSetNumberOfRuns(final int milliSecondsUnoptimised)
  {
    long time;
    numberOfRuns=1;
    for(int i=100; 0<i--;)
    {
      runUnoptimisedVersion();
      runOptimisedVersion();
    }//next i


    int count=0;

    time=System.currentTimeMillis() ;
    while(milliSecondsUnoptimised>(int)(System.currentTimeMillis() -time))
    { runUnoptimisedVersion();
      runOptimisedVersion();
      count++;
    }//wend
    numberOfRuns=count;

//System.err.println(count+" ("+getTestname()+")");//                    //DEBUG

  }//end-method
  private static int numberOfRuns=1;





  public final String getTestname()
  {
    return name;
  }


  public static void main(final String[] args)
  {
    (new IfElseTree_switch32()).runForEver();
  }



  public void runForEver()
  {
    //!!! not supported for EWE
  }//end-method



  public int runUnoptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("norm: (IfElseTree_switch32)"+switch_Version(numberOfRuns));
    switch_Version(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


  public int runOptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("opti: (IfElseTree_switch32)"+ifElseTree(numberOfRuns));
    ifElseTree(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  private static int switch_Version(int anz)
  {
    int erg=7;
    anz*=200000;

    while(0<anz--)
    {
      int j=-1;
      final int i=anz&31;
      switch(i)
      {
        case  0:j=299; break;
        case  1:j=298; break;
        case  2:j=297; break;
        case  3:j=296; break;
        case  4:j=295; break;
        case  5:j=294; break;
        case  6:j=293; break;
        case  7:j=292; break;
        case  8:j=291; break;
        case  9:j=290; break;
        case 10:j=289; break;
        case 11:j=288; break;
        case 12:j=287; break;
        case 13:j=286; break;
        case 14:j=285; break;
        case 15:j=284; break;
        case 16:j=283; break;
        case 17:j=282; break;
        case 18:j=281; break;
        case 19:j=280; break;
        case 20:j=279; break;
        case 21:j=278; break;
        case 22:j=277; break;
        case 23:j=276; break;
        case 24:j=275; break;
        case 25:j=274; break;
        case 26:j=273; break;
        case 27:j=272; break;
        case 28:j=271; break;
        case 29:j=270; break;
        case 30:j=269; break;
        case 31:j=268; break;
      }//end-switch
      erg+=j;
    }//wend
    return erg;
  }//end-method

  private static int ifElseTree(int anz)
  {
    int erg=7;
    anz*=200000;

    while(0<anz--)
    {
      int j=-1;
      final int i=anz&31;

      if(16>i)
      { if(8>i)
        { if(4>i)
          { if(2>i)
            { if(0==i)
                j=299;
              else if(1==i)
                j=298;
            }
            else // 2,3
            { if(2==i)
                j=297;
              else if(3==i)
                j=296;
            }
          }
          else // 4 .. 7
          { if(6>i)
            { if(4==i)
                j=295;
              else if(5==i)
                j=294;
            }
            else
            { if(6==i)
                j=293;
              else if(7==i)
                j=292;
            }
          }
        }
        else // 8 ... 15
        { if(12>i)
          { if(10>i)
            { if(8==i)
                j=291;
              else if(9==i)
                j=290;
            }
            else
            { if(10==i)
                j=289;
              else if(11==i)
                j=288;
            }
          }
          else
          { if(14>i)
            { if(12==i)
                j=287;
              else if(13==i)
                j=286;
            }
            else
            { if(14==i)
                j=285;
              else if(15==i)
                j=284;
            }
          }
        }
      }
      else // 16 ... 31
      { if(24>i)
        { if(20>i)
          { if(18>i)
            { if(16==i)
                j=283;
              else if(17==i)
                j=282;
            }
            else
            { if(18==i)
                j=281;
              else if(19==i)
                j=280;
            }
          }
          else
          { if(22>i)
            { if(20==i)
                j=279;
              else if(21==i)
                j=278;
            }
            else
            { if(22==i)
                j=277;
              else if(23==i)
                j=276;
            }
          }
        }
        else
        { if(28>i)
          { if(26>i)
            { if(24==i)
                j=275;
              else if(25==i)
                j=274;
            }
            else
            { if(26==i)
                j=273;
              else if(27==i)
                j=272;
            }
          }
          else
          { if(30>i)
            { if(28==i)
                j=271;
              else if(29==i)
                j=270;
            }
            else
            { if(30==i)
                j=269;
              else if(31==i)
                j=268;
            }
          }
        }
      }
      erg+=j;
    }//wend
    return erg;
  }//end-method

}//end-class
