//thsi test a swicht with 4 cases all with same probability

import ewe.sys.Vm;
public class IfElseTree_switch4 implements OptiTest
{
  private static final String name="'switch' replaced by 'if-else-tree' 4";


  public void findAndSetNumberOfRuns(final int milliSecondsUnoptimised)
  {
    long time;
    numberOfRuns=1;
    for(int i=100; 0<i--;)
    {
      runUnoptimisedVersion();
      runOptimisedVersion();
    }//next i


    int count=0;

    time=System.currentTimeMillis() ;
    while(milliSecondsUnoptimised>(int)(System.currentTimeMillis() -time))
    { runUnoptimisedVersion();
      runOptimisedVersion();
      count++;
    }//wend
    numberOfRuns=count;

//System.err.println(count+" ("+getTestname()+")");//                    //DEBUG

  }//end-method
  private static int numberOfRuns=1;





  public final String getTestname()
  {
    return name;
  }


  public static void main(final String[] args)
  {
    (new IfElseTree_switch4()).runForEver();
  }



  public void runForEver()
  {
    //!!! not supported for EWE
  }//end-method



  public int runUnoptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("norm: (IfElseTree_switch4)"+switch_Version(numberOfRuns));
    switch_Version(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


  public int runOptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("opti: (IfElseTree_switch4)"+ifElseTree(numberOfRuns));
    ifElseTree(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  private static int switch_Version(int anz)
  {
    int erg=7;
    anz*=200000;

    while(0<anz--)
    {
      int j=-1;
      final int i=anz&3;
      switch(i)
      {
        case  0:j=299; break;
        case  1:j=298; break;
        case  2:j=297; break;
        case  3:j=296; break;
      }//end-switch
      erg+=j;
    }//wend
    return erg;
  }//end-method

  private static int ifElseTree(int anz)
  {
    int erg=7;
    anz*=200000;

    while(0<anz--)
    {
      int j=-1;
      final int i=anz&3;

      if(2>i)
      { if(0==i)
          j=299;
        else if(1==i)
          j=298;
      }
      else // 2,3
      { if(2==i)
          j=297;
        else if(3==i)
          j=296;
      }
      erg+=j;
    }//wend
    return erg;
  }//end-method

}//end-class
