//Fazit: SHIFT statt DIV bringt sehr viel  server: 94,5%  client: 85,2% schneller
//       >> genauso teuer wie >>>

import ewe.sys.Vm;
public class Rekursiv_loop implements OptiTest
{
  private static final String name="Schleife statt Rekursion (Bsp. Fakultaet)";


  public void findAndSetNumberOfRuns(final int milliSecondsUnoptimised)
  {
    long time;
    numberOfRuns=1;
    for(int i=100; 0<i--;)
    {
      runUnoptimisedVersion();
      runOptimisedVersion();
    }//next i


    int count=0;

    time=System.currentTimeMillis() ;
    while(milliSecondsUnoptimised>(int)(System.currentTimeMillis() -time))
    { runUnoptimisedVersion();
      runOptimisedVersion();
      count++;
    }//wend
    numberOfRuns=count;

//System.err.println(count+" ("+getTestname()+")");//                    //DEBUG

  }//end-method
  private static int numberOfRuns=1;




  public static void main(final String[] args)
  {
    (new Rekursiv_loop()).runForEver();
  }//end-method


  public String getTestname()
  {
    return name;
  }

  public int runUnoptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("norm: (Rekursiv_loop)"+rek(numberOfRuns));
    rek(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method

  public int runOptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("opti: (Rekursiv_loop)"+loop(numberOfRuns));
    loop(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method

  public void runForEver()
  {
    //!!! not supported for EWE
  }//end-method


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  private static int rek(int anz)
  {
    anz*=200;
    int erg=7;
    while(0<=--anz)
    {
      for(int i=200; 0<=i; i--)
        erg+=fakultaet_rek(i);
    }//wend
    return erg;
  }//end-method

  private static int loop(int anz)
  {
    anz*=200;
    int erg=7;
    while(0<=--anz)
    {
      for(int i=200; 0<=i; i--)
        erg+=fakultaet_loop(i);
    }//wend
    return erg;
  }//end-method


  private static final int fakultaet_rek(final int n)
  {
    if(1>=n)
      return 1;
    return fakultaet_rek(n-1)*n;
  }

  private static final int fakultaet_loop(final int n)
  {
    int erg=1;
    for(int i=2; n>=i;)
      erg*=i++;
    return erg;
  }//end-method

}//end-class
