//thsi test a swicht with 128 cases all with same probability

import ewe.sys.Vm;
public class IfElseTree_switch128 implements OptiTest
{
  private static final String name="'switch' replaced by 'if-else-tree' 128";


  public void findAndSetNumberOfRuns(final int milliSecondsUnoptimised)
  {
    long time;
    numberOfRuns=1;
    for(int i=100; 0<i--;)
    {
      runUnoptimisedVersion();
      runOptimisedVersion();
    }//next i


    int count=0;

    time=System.currentTimeMillis() ;
    while(milliSecondsUnoptimised>(int)(System.currentTimeMillis() -time))
    { runUnoptimisedVersion();
      runOptimisedVersion();
      count++;
    }//wend
    numberOfRuns=count;

//System.err.println(count+" ("+getTestname()+")");//                    //DEBUG

  }//end-method
  private static int numberOfRuns=1;





  public final String getTestname()
  {
    return name;
  }


  public static void main(final String[] args)
  {
    (new IfElseTree_switch128()).runForEver();
  }



  public void runForEver()
  {
    //!!! not supported for EWE
  }//end-method



  public int runUnoptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("norm: (IfElseTree_switch128)"+switch_Version(numberOfRuns));
    switch_Version(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


  public int runOptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("opti: (IfElseTree_switch128)"+ifElseTree(numberOfRuns));
    ifElseTree(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  private static int switch_Version(int anz)
  {
    int erg=7;
    anz*=200000;

    while(0<anz--)
    {
      int j=-1;
      final int i=anz&127;
      switch(i)
      {
        case  0:j=299; break;
        case  1:j=298; break;
        case  2:j=297; break;
        case  3:j=296; break;
        case  4:j=295; break;
        case  5:j=294; break;
        case  6:j=293; break;
        case  7:j=292; break;
        case  8:j=291; break;
        case  9:j=290; break;
        case 10:j=289; break;
        case 11:j=288; break;
        case 12:j=287; break;
        case 13:j=286; break;
        case 14:j=285; break;
        case 15:j=284; break;
        case 16:j=283; break;
        case 17:j=282; break;
        case 18:j=281; break;
        case 19:j=280; break;
        case 20:j=279; break;
        case 21:j=278; break;
        case 22:j=277; break;
        case 23:j=276; break;
        case 24:j=275; break;
        case 25:j=274; break;
        case 26:j=273; break;
        case 27:j=272; break;
        case 28:j=271; break;
        case 29:j=270; break;
        case 30:j=269; break;
        case 31:j=268; break;
        case 32:j=267; break;
        case 33:j=266; break;
        case 34:j=265; break;
        case 35:j=264; break;
        case 36:j=263; break;
        case 37:j=262; break;
        case 38:j=261; break;
        case 39:j=260; break;
        case 40:j=259; break;
        case 41:j=258; break;
        case 42:j=257; break;
        case 43:j=256; break;
        case 44:j=255; break;
        case 45:j=254; break;
        case 46:j=253; break;
        case 47:j=252; break;
        case 48:j=251; break;
        case 49:j=250; break;
        case 50:j=249; break;
        case 51:j=248; break;
        case 52:j=247; break;
        case 53:j=246; break;
        case 54:j=245; break;
        case 55:j=244; break;
        case 56:j=243; break;
        case 57:j=242; break;
        case 58:j=241; break;
        case 59:j=240; break;
        case 60:j=239; break;
        case 61:j=238; break;
        case 62:j=237; break;
        case 63:j=236; break;

        case 64:j=1299; break;
        case 65:j=1298; break;
        case 66:j=1297; break;
        case 67:j=1296; break;
        case 68:j=1295; break;
        case 69:j=1294; break;
        case 70:j=1293; break;
        case 71:j=1292; break;
        case 72:j=1291; break;
        case 73:j=1290; break;
        case 74:j=1289; break;
        case 75:j=1288; break;
        case 76:j=1287; break;
        case 77:j=1286; break;
        case 78:j=1285; break;
        case 79:j=1284; break;
        case 80:j=1283; break;
        case 81:j=1282; break;
        case 82:j=1281; break;
        case 83:j=1280; break;
        case 84:j=1279; break;
        case 85:j=1278; break;
        case 86:j=1277; break;
        case 87:j=1276; break;
        case 88:j=1275; break;
        case 89:j=1274; break;
        case 90:j=1273; break;
        case 91:j=1272; break;
        case 92:j=1271; break;
        case 93:j=1270; break;
        case 94:j=1269; break;
        case 95:j=1268; break;
        case 96:j=1267; break;
        case 97:j=1266; break;
        case 98:j=1265; break;
        case 99:j=1264; break;
        case 100:j=1263; break;
        case 101:j=1262; break;
        case 102:j=1261; break;
        case 103:j=1260; break;
        case 104:j=1259; break;
        case 105:j=1258; break;
        case 106:j=1257; break;
        case 107:j=1256; break;
        case 108:j=1255; break;
        case 109:j=1254; break;
        case 110:j=1253; break;
        case 111:j=1252; break;
        case 112:j=1251; break;
        case 113:j=1250; break;
        case 114:j=1249; break;
        case 115:j=1248; break;
        case 116:j=1247; break;
        case 117:j=1246; break;
        case 118:j=1245; break;
        case 119:j=1244; break;
        case 120:j=1243; break;
        case 121:j=1242; break;
        case 122:j=1241; break;
        case 123:j=1240; break;
        case 124:j=1239; break;
        case 125:j=1238; break;
        case 126:j=1237; break;
        case 127:j=1236; break;
      }//end-switch
      erg+=j;
    }//wend
    return erg;
  }//end-method

  private static int ifElseTree(int anz)
  {
    int erg=7;
    anz*=200000;

    while(0<anz--)
    {
      int j=-1;
      final int i=anz&127;


      if(64>i)
      { if(32>i)
        { if(16>i)
          { if(8>i)
            { if(4>i)
              { if(2>i)
                { if(0==i)
                    j=299;
                  else if(1==i)
                    j=298;
                }
                else // 2,3
                { if(2==i)
                    j=297;
                  else if(3==i)
                    j=296;
                }
              }
              else // 4 .. 7
              { if(6>i)
                { if(4==i)
                    j=295;
                  else if(5==i)
                    j=294;
                }
                else
                { if(6==i)
                    j=293;
                  else if(7==i)
                    j=292;
                }
              }
            }
            else // 8 ... 15
            { if(12>i)
              { if(10>i)
                { if(8==i)
                    j=291;
                  else if(9==i)
                    j=290;
                }
                else
                { if(10==i)
                    j=289;
                  else if(11==i)
                    j=288;
                }
              }
              else
              { if(14>i)
                { if(12==i)
                    j=287;
                  else if(13==i)
                    j=286;
                }
                else
                { if(14==i)
                    j=285;
                  else if(15==i)
                    j=284;
                }
              }
            }
          }
          else // 16 ... 31
          { if(24>i)
            { if(20>i)
              { if(18>i)
                { if(16==i)
                    j=283;
                  else if(17==i)
                    j=282;
                }
                else
                { if(18==i)
                    j=281;
                  else if(19==i)
                    j=280;
                }
              }
              else
              { if(22>i)
                { if(20==i)
                    j=279;
                  else if(21==i)
                    j=278;
                }
                else
                { if(22==i)
                    j=277;
                  else if(23==i)
                    j=276;
                }
              }
            }
            else
            { if(28>i)
              { if(26>i)
                { if(24==i)
                    j=275;
                  else if(25==i)
                    j=274;
                }
                else
                { if(26==i)
                    j=273;
                  else if(27==i)
                    j=272;
                }
              }
              else
              { if(30>i)
                { if(28==i)
                    j=271;
                  else if(29==i)
                    j=270;
                }
                else
                { if(30==i)
                    j=269;
                  else if(31==i)
                    j=268;
                }
              }
            }
          }
        }
        else //32 ... 63
        { if(48>i)
          { if(40>i)
            { if(36>i)
              { if(34>i)
                { if(32==i)
                    j=267;
                  else if(33==i)
                    j=266;
                }
                else
                { if(34==i)
                    j=265;
                  else if(35==i)
                    j=264;
                }
              }
              else
              { if(38>i)
                { if(36==i)
                    j=263;
                  else if(37==i)
                    j=262;
                }
                else
                { if(38==i)
                    j=261;
                  else if(39==i)
                    j=260;
                }
              }
            }
            else
            { if(44>i)
              { if(42>i)
                { if(40==i)
                    j=259;
                  else if(41==i)
                    j=258;
                }
                else
                { if(42==i)
                    j=257;
                  else if(43==i)
                    j=256;
                }
              }
              else
              { if(46>i)
                { if(44==i)
                    j=255;
                  else if(45==i)
                    j=254;
                }
                else
                { if(46==i)
                    j=253;
                  else if(47==i)
                    j=252;
                }
              }
            }
          }
          else
          { if(56>i)
            { if(52>i)
              { if(50>i)
                { if(48==i)
                    j=251;
                  else if(49==i)
                    j=250;
                }
                else
                { if(50==i)
                    j=249;
                  else if(51==i)
                    j=248;
                }
              }
              else
              { if(54>i)
                { if(52==i)
                    j=247;
                  else if(53==i)
                    j=246;
                }
                else
                { if(54==i)
                    j=245;
                  else if(55==i)
                    j=244;
                }
              }
            }
            else
            { if(60>i)
              { if(58>i)
                { if(56==i)
                    j=243;
                  else if(57==i)
                    j=242;
                }
                else
                { if(58==i)
                    j=241;
                  else if(59==i)
                    j=240;
                }
              }
              else
              { if(62>i)
                { if(60==i)
                    j=239;
                  else if(61==i)
                    j=238;
                }
                else
                { if(62==i)
                    j=237;
                  else if(63==i)
                    j=236;
                }
              }
            }
          }
        }
      }
      else //i>=64
      { if(96>i)
        { if(80>i)
          { if(72>i)
            { if(68>i)
              { if(66>i)
                { if(64==i)
                    j=1299;
                  else if(65==i)
                    j=1298;
                }
                else // 66,67
                { if(66==i)
                    j=1297;
                  else if(67==i)
                    j=1296;
                }
              }
              else // 68 .. 71
              { if(70>i)
                { if(68==i)
                    j=1295;
                  else if(69==i)
                    j=1294;
                }
                else
                { if(70==i)
                    j=1293;
                  else if(71==i)
                    j=1292;
                }
              }
            }
            else // 8+64 ... 15+64
            { if(76>i)
              { if(74>i)
                { if(72==i)
                    j=1291;
                  else if(73==i)
                    j=1290;
                }
                else
                { if(74==i)
                    j=1289;
                  else if(75==i)
                    j=1288;
                }
              }
              else
              { if(78>i)
                { if(76==i)
                    j=1287;
                  else if(77==i)
                    j=1286;
                }
                else
                { if(78==i)
                    j=1285;
                  else if(79==i)
                    j=1284;
                }
              }
            }
          }
          else // 16+64 ... 31+64
          { if(88>i)
            { if(84>i)
              { if(82>i)
                { if(80==i)
                    j=1283;
                  else if(81==i)
                    j=1282;
                }
                else
                { if(82==i)
                    j=1281;
                  else if(83==i)
                    j=1280;
                }
              }
              else
              { if(86>i)
                { if(84==i)
                    j=1279;
                  else if(85==i)
                    j=1278;
                }
                else
                { if(86==i)
                    j=1277;
                  else if(87==i)
                    j=1276;
                }
              }
            }
            else
            { if(92>i)
              { if(90>i)
                { if(88==i)
                    j=1275;
                  else if(89==i)
                    j=1274;
                }
                else
                { if(90==i)
                    j=1273;
                  else if(91==i)
                    j=1272;
                }
              }
              else
              { if(94>i)
                { if(92==i)
                    j=1271;
                  else if(93==i)
                    j=1270;
                }
                else
                { if(94==i)
                    j=1269;
                  else if(95==i)
                    j=1268;
                }
              }
            }
          }
        }
        else //32+64 ... 63+64
        { if(112>i)
          { if(104>i)
            { if(100>i)
              { if(98>i)
                { if(96==i)
                    j=1267;
                  else if(97==i)
                    j=1266;
                }
                else
                { if(98==i)
                    j=1265;
                  else if(99==i)
                    j=1264;
                }
              }
              else
              { if(102>i)
                { if(100==i)
                    j=1263;
                  else if(101==i)
                    j=1262;
                }
                else
                { if(102==i)
                    j=1261;
                  else if(103==i)
                    j=1260;
                }
              }
            }
            else
            { if(108>i)
              { if(106>i)
                { if(104==i)
                    j=1259;
                  else if(105==i)
                    j=1258;
                }
                else
                { if(106==i)
                    j=1257;
                  else if(107==i)
                    j=1256;
                }
              }
              else
              { if(110>i)
                { if(108==i)
                    j=1255;
                  else if(109==i)
                    j=1254;
                }
                else
                { if(110==i)
                    j=1253;
                  else if(111==i)
                    j=1252;
                }
              }
            }
          }
          else
          { if(120>i)
            { if(116>i)
              { if(114>i)
                { if(112==i)
                    j=1251;
                  else if(113==i)
                    j=1250;
                }
                else
                { if(114==i)
                    j=1249;
                  else if(115==i)
                    j=1248;
                }
              }
              else
              { if(118>i)
                { if(116==i)
                    j=1247;
                  else if(117==i)
                    j=1246;
                }
                else
                { if(118==i)
                    j=1245;
                  else if(119==i)
                    j=1244;
                }
              }
            }
            else
            { if(124>i)
              { if(122>i)
                { if(120==i)
                    j=1243;
                  else if(121==i)
                    j=1242;
                }
                else
                { if(122==i)
                    j=1241;
                  else if(123==i)
                    j=1240;
                }
              }
              else
              { if(126>i)
                { if(124==i)
                    j=1239;
                  else if(125==i)
                    j=1238;
                }
                else
                { if(126==i)
                    j=1237;
                  else if(127==i)
                    j=1236;
                }
              }
            }
          }
        }
      }
      erg+=j;
    }//wend
    return erg;
  }//end-method

}//end-class
